src/Entity/Booking.php
<?php

namespace App\Entity;

use ApiPlatform\Core\Annotation\ApiResource;
use App\Repository\BookingRepository;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Serializer\Annotation\Groups;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity(repositoryClass=BookingRepository::class)
 * @ORM\HasLifecycleCallbacks()
 * @ApiResource(
 * normalizationContext={
 *    "groups"={"bookings_read"}
 *   },
 * collectionOperations={"GET", "POST"},
 * itemOperations={"GET", "PUT", "DELETE"},
 * attributes={
 *    "pagination_enabled"=true,
 *    "pagination_items_per_page"=15,
 *    "pagination_client_enabled"=true,
 *    "pagination_client_items_per_page"=true,
 *    "pagination_items_per_page_parameter_name"="count",
 *   }
 * )
 */
class Booking
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     * @Groups({"bookings_read","users_read"})
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="bookings")
     * @ORM\JoinColumn(nullable=false)
     * @Groups({"bookings_read","users_read"})
     */
    private $booker;

    /**
     * @ORM\ManyToOne(targetEntity=Ad::class, inversedBy="bookings")
     * @ORM\JoinColumn(nullable=false)
     * @Groups({"bookings_read","users_read"})
     */
    private $ad;

    /**
     * @ORM\Column(type="datetime")
     * @Groups({"bookings_read"})
     */
    private $startDate;

    /**
     * @ORM\Column(type="datetime")
     * @Assert\GreaterThan(propertyPath="startDate", message="La date de réservaion doit être plus éloigné que la date de retour.")
     * @Groups({"bookings_read"})
     */
    private $endDate;

    /**
     * @ORM\Column(type="datetime")
     * @Groups({"bookings_read"})
     */
    private $createdAt;

    /**
     * @ORM\Column(type="float")
     * @Groups({"bookings_read"})
     */
    private $amount;

    /**
     * @ORM\Column(type="text", nullable=true)
     * @Groups({"bookings_read"})
     */
    private $comment;

    /**
     * Permet de récupérer un tableau des journées qui correspondent à ma réservation.
     *
     * @return array Un tableau d'objets DateTime représentant les jours de la réservation
     */
    public function getDays()
    {
        $result = range(
            $this->startDate->getTimestamp(),
            $this->endDate->getTimestamp(),
            24 * 60 * 60
        );

        $days = array_map(function ($dayTimestamp) {
            return new \DateTime(date('Y-m-d', $dayTimestamp));
        }, $result);

        return $days;
    }

    /**
     * Undocumented function.
     *
     * @return bool
     */
    public function isBookableDates()
    {
        //savoir si les dates impossible
        $notAvailableDays = $this->ad->getNotAvailableDays();
        //comparer les dates choisis avec dates impossible
        $bookingDays = $this->getDays();

        $formatDay = function ($day) {
            return $day->format('Y-m-d');
        };
        //tableau qui contient mes chaines de caractères de mes journées
        $days = array_map($formatDay, $bookingDays);
        $notAvailable = array_map($formatDay, $notAvailableDays);
        //comparaison des journées dispo et indispo
        foreach ($days as $day) {
            if (false !== array_search($day, $notAvailable)) {
                return false;
            }

            return true;
        }
    }

    /**
     * Callback appelé à chaque réservation.
     *
     * @ORM\PrePersist
     * @ORM\PreUpdate
     *
     * @return void
     */
    public function prePersist()
    {
        if (empty($this->createdAt)) {
            $this->createdAt = new \DateTime();
        }
        if (empty($this->amount)) {
            $this->amount = $this->ad->getPrice() * $this->getDuration();
        }
    }

    public function getDuration()
    {
        $diff = $this->endDate->diff($this->startDate);

        return $diff->days;
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getBooker(): ?User
    {
        return $this->booker;
    }

    public function setBooker(?User $booker): self
    {
        $this->booker = $booker;

        return $this;
    }

    public function getAd(): ?Ad
    {
        return $this->ad;
    }

    public function setAd(?Ad $ad): self
    {
        $this->ad = $ad;

        return $this;
    }

    public function getStartDate(): ?\DateTimeInterface
    {
        return $this->startDate;
    }

    public function setStartDate(\DateTimeInterface $startDate): self
    {
        $this->startDate = $startDate;

        return $this;
    }

    public function getEndDate(): ?\DateTimeInterface
    {
        return $this->endDate;
    }

    public function setEndDate(\DateTimeInterface $endDate): self
    {
        $this->endDate = $endDate;

        return $this;
    }

    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->createdAt;
    }

    public function setCreatedAt(\DateTimeInterface $createdAt): self
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    public function getAmount(): ?float
    {
        return $this->amount;
    }

    public function setAmount(float $amount): self
    {
        $this->amount = $amount;

        return $this;
    }

    public function getComment(): ?string
    {
        return $this->comment;
    }

    public function setComment(?string $comment): self
    {
        $this->comment = $comment;

        return $this;
    }
}

src/Entity/User.php
<?php

namespace App\Entity;

use App\Repository\UserRepository;
use Cocur\Slugify\Slugify;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Serializer\Annotation\Groups;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity(repositoryClass=UserRepository::class)
 * @ORM\HasLifecycleCallbacks()
 * @UniqueEntity(
 *  fields={"email"},
 * message="un autre utilisateur s'est déjà inscrit avec cette adresse email, merci de la modifier"
 * )
 */
class User implements UserInterface
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     * @Groups({"users_read"})
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="vous devez renseigner votre prénom")
     * @Groups({"users_read"})
     */
    private $firstName;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="vous devez renseigner votre nom")
     * @Groups({"users_read"})
     */
    private $lastName;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Email(message="Veuillez renseigner un email valide !")
     * @Groups({"users_read"})
     */
    private $email;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @Groups({"users_read"})
     */
    private $picture;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $hash;

    /**
     * @Assert\EqualTo(propertyPath="hash",message="Vous n'avez pas correctement confirmé votre mot de passe")
     */
    public $passwordConfirm;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Length(min=10,minMessage="Votre introduction doit faire au moins 10 caractère")
     * @Groups({"users_read"})
     */
    private $introduction;

    /**
     * @ORM\Column(type="text")
     * @Assert\Length(min=100,minMessage="Votre description doit faire au moins 100 caractère")
     * @Groups({"users_read"})
     */
    private $description;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $slug;

    /**
     * @ORM\OneToMany(targetEntity=Ad::class, mappedBy="author")
     * @Groups({"users_read"})
     */
    private $ads;

    /**
     * @ORM\ManyToMany(targetEntity=Role::class, mappedBy="users")
     */
    private $userRoles;

    /**
     * @ORM\OneToMany(targetEntity=Booking::class, mappedBy="booker")
     * @Groups({"users_read"})
     */
    private $bookings;

    /**
     * @ORM\OneToMany(targetEntity=Comment::class, mappedBy="author", orphanRemoval=true)
     * @Groups({"users_read"})
     */
    private $comments;

    public function getFullName()
    {
        return "{$this->firstName} {$this->lastName}";
    }

    /**
     * Permet d'initialiser le Slug.
     *
     * @ORM\PrePersist
     * @ORM\PreUpdate
     *
     * @return void
     */
    public function initializeSlug()
    {
        if (empty($this->slug)) {
            $slugify = new Slugify();
            $this->slug = $slugify->slugify($this->firstName.' '.$this->lastName);
        }
    }

    public function __construct()
    {
        $this->ads = new ArrayCollection();
        $this->userRoles = new ArrayCollection();
        $this->bookings = new ArrayCollection();
        $this->comments = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getFirstName(): ?string
    {
        return $this->firstName;
    }

    public function setFirstName(string $firstName): self
    {
        $this->firstName = $firstName;

        return $this;
    }

    public function getLastName(): ?string
    {
        return $this->lastName;
    }

    public function setLastName(string $lastName): self
    {
        $this->lastName = $lastName;

        return $this;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    public function getPicture(): ?string
    {
        return $this->picture;
    }

    public function setPicture(?string $picture): self
    {
        $this->picture = $picture;

        return $this;
    }

    public function getHash(): ?string
    {
        return $this->hash;
    }

    public function setHash(string $hash): self
    {
        $this->hash = $hash;

        return $this;
    }

    public function getIntroduction(): ?string
    {
        return $this->introduction;
    }

    public function setIntroduction(string $introduction): self
    {
        $this->introduction = $introduction;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    /**
     * Undocumented function.
     *
     * @return array
     */
    public function getRoles()
    {
        $roles = $this->userRoles->map(function ($role) {
            return $role->getTitle();
        })->toArray();
        $roles[] = 'ROLE_USER';

        return $roles;
    }

    /**
     * Undocumented function.
     *
     * @return void
     */
    public function getPassword()
    {
        return $this->hash;
    }

    public function getUsername()
    {
        return $this->email;
    }

    public function getSalt()
    {
    }

    public function eraseCredentials()
    {
    }

    /**
     * @return Collection|Ad[]
     */
    public function getAds(): Collection
    {
        return $this->ads;
    }

    public function addAd(Ad $ad): self
    {
        if (!$this->ads->contains($ad)) {
            $this->ads[] = $ad;
            $ad->setAuthor($this);
        }

        return $this;
    }

    public function removeAd(Ad $ad): self
    {
        if ($this->ads->removeElement($ad)) {
            // set the owning side to null (unless already changed)
            if ($ad->getAuthor() === $this) {
                $ad->setAuthor(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Role[]
     */
    public function getUserRoles(): Collection
    {
        return $this->userRoles;
    }

    public function addUserRole(Role $userRole): self
    {
        if (!$this->userRoles->contains($userRole)) {
            $this->userRoles[] = $userRole;
            $userRole->addUser($this);
        }

        return $this;
    }

    public function removeUserRole(Role $userRole): self
    {
        if ($this->userRoles->removeElement($userRole)) {
            $userRole->removeUser($this);
        }

        return $this;
    }

    /**
     * @return Collection|Booking[]
     */
    public function getBookings(): Collection
    {
        return $this->bookings;
    }

    public function addBooking(Booking $booking): self
    {
        if (!$this->bookings->contains($booking)) {
            $this->bookings[] = $booking;
            $booking->setBooker($this);
        }

        return $this;
    }

    public function removeBooking(Booking $booking): self
    {
        if ($this->bookings->removeElement($booking)) {
            // set the owning side to null (unless already changed)
            if ($booking->getBooker() === $this) {
                $booking->setBooker(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Comment[]
     */
    public function getComments(): Collection
    {
        return $this->comments;
    }

    public function addComment(Comment $comment): self
    {
        if (!$this->comments->contains($comment)) {
            $this->comments[] = $comment;
            $comment->setAuthor($this);
        }

        return $this;
    }

    public function removeComment(Comment $comment): self
    {
        if ($this->comments->removeElement($comment)) {
            // set the owning side to null (unless already changed)
            if ($comment->getAuthor() === $this) {
                $comment->setAuthor(null);
            }
        }

        return $this;
    }
}

src/Controller/BookingController.php
<?php

namespace App\Controller;

use App\Entity\Ad;
use App\Entity\Booking;
use App\Entity\Comment;
use App\Form\BookingType;
use App\Form\CommentType;
use Doctrine\ORM\EntityManagerInterface;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class BookingController extends AbstractController
{
    /**
     * @Route("/ads/{slug}/book", name="booking_create")
     * @IsGranted("ROLE_USER")
     */
    public function book(Ad $ad, Request $request, EntityManagerInterface $manager): Response
    {
        $booking = new Booking();
        $form = $this->createForm(BookingType::class, $booking);

        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $user = $this->getUser();

            $booking->setBooker($user)
                ->setAd($ad);

            //si les date ne sont pas dispo echo erreur
            if (!$booking->isBookableDates()) {
                $this->addFlash(
                    'warning',
                    'les dates choisis ne sont pas disponible pour ce produit.'
                );
            } else {
                $manager->persist($booking);
                $manager->flush();

                return $this->redirectToRoute('booking_show', ['id' => $booking->getId(),
                'widthAlertSuccess' => true, ]);
            }
        }

        return $this->render('booking/book.html.twig', [
            'ad' => $ad,
            'form' => $form->createView(),
        ]);
    }

    /**
     * Permet d'afficher la page d'une réservation.
     *
     * @Route("/booking/{id}", name="booking_show")
     *
     * @param EntityManagerInterfaces $manager
     *
     * @return Response
     */
    public function show(Booking $booking, Request $request, EntityManagerInterface $manager)
    {
        $comment = new Comment();

        $form = $this->createForm(CommentType::class, $comment);

        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $comment->setAd($booking->getAd())
                    ->setAuthor($this->getUser());
            $manager->persist($comment);
            $manager->flush();
            $this->addFlash(
                'success',
                'Votre commentaire a bien été pris en compte !'
            );
        }

        return $this->render('booking/show.html.twig', [
            'booking' => $booking,
            'form' => $form->createView(),
        ]);
    }
}

templates/booking/book.html.twig
{% extends 'base.html.twig' %}

{% block title %}Réserver l'annonce : {{ad.title}}{% endblock %}

{% block stylesheets %}
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/css/bootstrap-datepicker.min.css" integrity="sha512-mSYUmp1HYZDFaVKK//63EcZq4iFWFjxSL+Z3T/aCt4IO9Cejm03q3NKKYN6pFQzY0SBOr8h+eCIAZHPXcpZaNw==" crossorigin="anonymous" />
{% endblock %}

{% block body %}
<div class="container mat7">
    <h1class="my-5">Réserver pour l'annonce : <em>{{ad.title}}</em></h1class=>
    <p>Vous êtes sur le point de réserver le bien de : <strong>{{ad.author.fullName}}
    </strong>, dites nous tout, on s'occupe du reste !</p>

    {{ form_start(form) }}
    <div class="alert alert-light">
        <h2 class="tac h4">Commencez par nous dire quelles sont les dates qui vous intéressent !</h2>
        <div class="row">
            <div class="col">
                {{ form_row(form.startDate) }}
            </div>
            <div class="col">
                {{ form_row(form.endDate) }}
            </div>
        </div>
        <h4 class="mt-2">Montant de la location : <span id="amount">....</span> &euro;</h4>
        <span id="days">0</span> jour(s) à {{ad.price | number_format(2, ',', ' ') }}&euro; par jour</span>

        <h4 class="mt-3">Vous avez un commentaire ?</h4>
        {{form_row(form.comment)}}
    </div>


    <h2>Vous avez terminé ?</h2>
    <p>Besoin personnel ? Besoin professionnel ? Peu import, on est aves vous !</p>

    <button type="submit" class="btn btn-success">Je réserve !</button>

    {{ form_end(form) }}
</div>
{% endblock %}

{% block javascripts %}
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/js/bootstrap-datepicker.min.js" integrity="sha512-T/tUfKSV1bihCnd+MxKD0Hm1uBBroVYBOYSk1knyvQ9VyZJpc/ALb4P0r6ubwVPSGB2GvjeoMAJJImBG12TiaQ==" crossorigin="anonymous"></script>
<script>
    $(document).ready(function(){
        $('#booking_startDate, #booking_endDate').datepicker({
            format: 'dd/mm/yyyy',
            datesDisabled: [
                {% for day in ad.notAvailableDays %}
                    "{{ day.format('d/m/Y') }}",
                {% endfor %}
            ],
            startDate: new Date()
        });
        $('#booking_startDate, #booking_endDate').on('change',calculateAmount);
    });

    function calculateAmount(){
        //on récupère les dates
        const endDate = new Date($('#booking_endDate').val().replace(/(\d+)\/(\d+)\/(\d{4})/, '$3-$2-$1'));
        const startDate = new Date($('#booking_startDate').val().replace(/(\d+)\/(\d+)\/(\d{4})/, '$3-$2-$1'));

        if(startDate && endDate && startDate < endDate){
            const DAY_TIME = 24*60*60*1000;
            const interval = endDate.getTime() - startDate.getTime();
            const days = interval/DAY_TIME;
            const amount = days * {{ ad.price }}

            $('#days').text(days);
            $('#amount').text(amount.toLocaleString('fr-FR'));

        }
    }
</script>
{% endblock %}

templates/booking/show.html.twig
{% extends 'base.html.twig' %}
{% block title %}Réservation n°{{booking.id}}{% endblock %}
{% block body %}
{% set ad = booking.ad %}
{% set author = ad.author %}
    <div class="container mat7">
        <h1 class="maTmaB tac">Votre réservation (n°{{booking.id}})</h1>
        {% if app.request.query.get('widthAlertSuccess') %}
            <div class="alert alert-success">
                <h4 class="alert-heading">Bravo !</h4>
                <p>
                    Votre réservation auprès de
                    <strong>
                        <a href="{{path('user_show', {"slug":author.slug})}}">{{author.fullName}}</a>
                    </strong>
                    pour l'annonce
                    <strong>
                        <a href="{{path('ads_show', {"slug":ad.slug})}}">{{ad.title}}</a>
                    </strong>
                </p>
            </div>
        {% endif %}
        <div class="row">
            <div class="alert alert-light">
                <h2>Détails</h2>
                <dl class="row">
                    <dt class="col-md-4">Numéro</dt>
                    <dd class="col-md-8">{{booking.id}}</dd>
                    <dt class="col-md-4">Date de prise en main</dt>
                    <dd class="col-md-8">{{booking.startDate | date('d/m/Y')}}</dd>
                    <dt class="col-md-4">Date de retour</dt>
                    <dd class="col-md-8">{{booking.endDate | date('d/m/Y')}}</dd>
                    <dt class="col-md-4">Nombre de jour</dt>
                    <dd class="col-md-8">{{booking.duration}}</dd>
                    <dt class="col-md-4">Montant total</dt>
                    <dd class="col-md-8">{{booking.amount | number_format(2, ',', ' ') }}&euro;</dd>
                    <dt class="col-md-4">COmmentaire</dt>
                    <dd class="col-md-8">{{booking.comment | default('Aucuns commentaires') }}</dd>
                </dl> 
                <hr>
                <h2 class="tac alert-heading">Votre client</h2>
                <div class="row mb-3">
                    <div class="col-3">
                        <img src="{{author.picture}}" class="avatar avatar-medium" alt="Avatar de {{author.fullName}}"/>
                    </div>
                    <div class="col-9">
                        <h4>
                            <a href="{{path('user_show', {'slug': author.slug})}}">{{author.fullName}}</a>
                        </h4>
                        <span class="badge badge-primary">{{author.ads|length}} annonces</span>
                    </div>
                </div>
                {{author.description | raw}}
                <a class="btn btn-primary" href="{{path('user_show', {'slug':author.slug})}}">Plus d'infos sur {{author.firstName}}</a>
            </div>

            <div class="alet alert-light" id="comment">
                <h2 class="tac alert-heading">Votre avis compte !</h2>
                {% if date() > date(booking.endDate) %}
                    {% set comment = booking.ad.commentFromAuthor(app.user) %}
                    {% if comment is not null %}
                        <blockquote>
                            {{comment.content}}
                        </blockquote>
                        <strong>Note : </strong> {% include 'partials/rating.html.twig' with {'rating': comment.rating} %}
                    {% else %}
                        {{ form_start(form) }}
                        {{ form_widget(form) }}
                        <button type="submit" class="btn btn-success">Confirmer !</button>
                        {{ form_end(form) }}
                    {% endif %}
                {% else %}
                <p>Vous ne pouvez pas noté cette annonce tant que vous n'avez pas rendu le produit !</p>
                {% endif %}
            </div>

        </div>
        <div class="col">
            <div class="alert alert-light">
                <h2 class="tac alert-heading">Votre location</h2>
                <h4>
                    <a href="{{path('ads_show', {'slug': author.slug})}}">{{ad.title}}</a>
                </h4>
                <img src="{{ad.coverImage}}" class="img-fluid" alt="Image de {{ad.title}}"/>
                {{ad.introduction | raw}}
                <a href="{{path('ads_show', {'slug': ad.slug})}}" class="btn btn-primary mt-3">Plus d'informations</a>
            </div>
        </div>
    </div>
{% endblock %}